<template>
  <div class="col_left">
    <div class="sort-mobile d-flex items-center">
      <!-- <strong>Sắp xếp theo:</strong>
      <select id="resizing_select">
        <option>Giá thấp</option>
        <option>Giá cao</option>
        <option>Hàng mới</option>
        <option>Bán chạy</option>
        <option>Chọn lọc</option>
      </select>
      <select id="width_tmp_select">
        <option id="width_tmp_option"></option>
      </select> -->
      <div class="fillter" @click="showFilter = true">
        <svg-icon name="filter"></svg-icon>
        Lọc
        <span>
          ({{
            page !== 'brand'
              ? product_filters.brands.length
              : product_filters.sub_brands.length
          }})
        </span>
      </div>
    </div>
    <div class="txt_16 tong_sp">
      <strong>{{ (meta.from || 0) + ' - ' + (meta.to || 0) }}</strong>
      trên {{ meta.total }} sản phẩm
    </div>
    <div
      class="catalogue-wrap sticky"
      :class="[showFilter ? 'show' : backStep ? 'back-step' : '']"
    >
      <div class="back_step">
        <a
          class="back"
          href="javascript:;"
          @click="
            backStep = true
            showFilter = false
          "
        >
          <svg-icon name="arrow-left"></svg-icon>
        </a>
        <h2 class="title_cate">
          <span>Lọc</span>
        </h2>
        <a
          class="btn-default apply"
          href="javascript:;"
          @click="
            backStep = true
            showFilter = false
          "
        >
          Áp dụng
        </a>
      </div>
      <div class="catalogue catalogue_final">
        <div class="d-flex items-center">
          <h3>Bộ lọc được áp dụng</h3>
          <a
            class="cancel ml-auto"
            href="javascript:;"
            @click.prevent="clearFilters"
          >
            Bỏ lọc
          </a>
        </div>
        <ul>
          <template v-if="page !== 'brand'">
            <li
              v-for="(brand_item, index) in product_filters.brands"
              :key="brand_item.name"
            >
              {{ brands.find((i) => i.id === brand_item).name }}
              <a
                class="iconfont-close"
                @click.prevent="product_filters.brands.splice(index, 1)"
              ></a>
            </li>
          </template>
          <template v-else>
            <li
              v-for="(sub, index) in product_filters.sub_brands"
              :key="sub.name"
            >
              {{ brand.sub_brands.find((i) => i.id === sub).name }}
              <a
                class="iconfont-close"
                @click.prevent="product_filters.sub_brands.splice(index, 1)"
              ></a>
            </li>
          </template>

          <li v-for="(type, index) in option_filters.type" :key="type.name">
            {{ listFilters.type.find((i) => i.id === type).name }}
            <a
              class="iconfont-close"
              @click.prevent="option_filters.type.splice(index, 1)"
            ></a>
          </li>
          <li
            v-for="(status, index) in option_filters.status"
            :key="status.name"
          >
            {{ listFilters.status.find((i) => i.id === status).name }}
            <a
              class="iconfont-close"
              @click.prevent="option_filters.status.splice(index, 1)"
            ></a>
          </li>
          <li
            v-for="(range, index) in option_filters.price_range"
            :key="range.name"
          >
            {{ listFilters.price_range.find((i) => i.id === range).name }}
            <a
              class="iconfont-close"
              @click.prevent="option_filters.price_range.splice(index, 1)"
            ></a>
          </li>
          <li
            v-for="(cpu_name, index) in option_filters.cpu_name"
            :key="cpu_name"
          >
            {{ cpu_name }}
            <a
              class="iconfont-close"
              @click.prevent="option_filters.cpu_name.splice(index, 1)"
            ></a>
          </li>
          <li v-for="(ram, index) in option_filters.ram" :key="ram">
            {{ ram }}
            <a
              class="iconfont-close"
              @click.prevent="option_filters.ram.splice(index, 1)"
            ></a>
          </li>
          <li v-for="(storage, index) in option_filters.storage" :key="storage">
            {{ storage }}
            <a
              class="iconfont-close"
              @click.prevent="option_filters.storage.splice(index, 1)"
            ></a>
          </li>
          <li
            v-for="(display_size, index) in option_filters.display_size"
            :key="display_size"
          >
            {{ display_size }}
            <a
              class="iconfont-close"
              @click.prevent="option_filters.display_size.splice(index, 1)"
            ></a>
          </li>
          <li
            v-for="(display_type, index) in option_filters.display_type"
            :key="display_type.name"
          >
            {{
              listFilters.display_type.find((i) => i.id === display_type).name
            }}
            <a
              class="iconfont-close"
              @click.prevent="option_filters.display_type.splice(index, 1)"
            ></a>
          </li>
          <li
            v-for="(display_res, index) in option_filters.display_res"
            :key="display_res"
          >
            {{ display_res }}
            <a
              class="iconfont-close"
              @click.prevent="option_filters.display_res.splice(index, 1)"
            ></a>
          </li>
          <li
            v-for="(gpu_onboard, index) in option_filters.gpu_onboard"
            :key="gpu_onboard"
          >
            {{ gpu_onboard }}
            <a
              class="iconfont-close"
              @click.prevent="option_filters.gpu_onboard.splice(index, 1)"
            ></a>
          </li>
          <li
            v-for="(gpu_vram, index) in option_filters.gpu_vram"
            :key="gpu_vram"
          >
            {{ gpu_vram }}
            <a
              class="iconfont-close"
              @click.prevent="option_filters.gpu_vram.splice(index, 1)"
            ></a>
          </li>
          <li
            v-for="(weight, index) in option_filters.weight"
            :key="weight.name"
          >
            {{ weight.name }}
            <a
              class="iconfont-close"
              @click.prevent="option_filters.weight.splice(index, 1)"
            ></a>
          </li>
        </ul>
      </div>
      <div v-if="page !== 'brand'" class="catalogue">
        <h3>Thương hiệu</h3>
        <div class="catalogue__list">
          <label
            v-for="item in brandsFirst"
            :key="item.name"
            class="check-list"
          >
            <span class="text">{{ item.name }}</span>
            <input
              v-model="product_filters.brands"
              type="checkbox"
              :value="item.id"
            />
            <span class="checkmark"></span>
          </label>
          <a
            v-if="brandsFirst.length == 6"
            class="view-more"
            @click="moreBrands"
          >
            Xem thêm thương hiệu
          </a>
        </div>
      </div>
      <div v-if="page === 'brand'" class="catalogue">
        <h3 class="active">Thương hiệu nhánh</h3>
        <div class="show catalogue__list">
          <label
            v-for="sub in brand.sub_brands"
            :key="sub.name"
            class="check-list"
          >
            <span class="text">{{ sub.name }}</span>
            <input
              v-model="product_filters.sub_brands"
              type="checkbox"
              :value="sub.id"
            />
            <span class="checkmark"></span>
          </label>
        </div>
      </div>
      <div v-if="listFilters.price_range" class="catalogue">
        <h3 :class="{ active: option_filters.price_range.length }">
          Khoảng giá
        </h3>
        <div
          class="catalogue__list"
          :class="{ show: option_filters.price_range.length }"
        >
          <label
            v-for="range in listFilters.price_range"
            :key="range.name"
            class="check-list"
          >
            <span class="text">{{ range.name }}</span>
            <input
              v-model="option_filters.price_range"
              type="checkbox"
              :value="range.id"
            />
            <span class="checkmark"></span>
          </label>
        </div>
      </div>
      <div v-if="listFilters.type" class="catalogue">
        <h3 :class="{ active: option_filters.type.length }">Loại hàng</h3>
        <div
          class="catalogue__list"
          :class="{ show: option_filters.type.length }"
        >
          <label
            v-for="type in listFilters.type"
            :key="type.name"
            class="check-list"
          >
            <span class="text">{{ type.name }}</span>
            <input
              v-model="option_filters.type"
              type="checkbox"
              :value="type.id"
            />
            <span class="checkmark"></span>
          </label>
        </div>
      </div>
      <div v-if="listFilters.status" class="catalogue">
        <h3 :class="{ active: option_filters.status.length }">Tình trạng</h3>
        <div
          class="catalogue__list"
          :class="{ show: option_filters.status.length }"
        >
          <label
            v-for="status in listFilters.status"
            :key="status.name"
            class="check-list"
          >
            <span class="text">{{ status.name }}</span>
            <input
              v-model="option_filters.status"
              type="checkbox"
              :value="status.id"
            />
            <span class="checkmark"></span>
          </label>
        </div>
      </div>
      <div v-if="listFilters.cpu_name" class="catalogue">
        <h3 :class="{ active: option_filters.cpu_name.length }">CPU</h3>
        <div
          class="catalogue__list"
          :class="{ show: option_filters.cpu_name.length }"
        >
          <label
            v-for="cpu in listFilters.cpu_name"
            :key="cpu"
            class="check-list"
          >
            <span class="text">{{ cpu }}</span>
            <input
              v-model="option_filters.cpu_name"
              type="checkbox"
              :value="cpu"
            />
            <span class="checkmark"></span>
          </label>
        </div>
      </div>
      <div v-if="listFilters.ram" class="catalogue">
        <h3 :class="{ active: option_filters.ram.length }">RAM</h3>
        <div
          :class="{ show: option_filters.ram.length }"
          class="catalogue__list"
        >
          <label v-for="ram in listFilters.ram" :key="ram" class="check-list">
            <span class="text">{{ ram }}</span>
            <input v-model="option_filters.ram" type="checkbox" :value="ram" />
            <span class="checkmark"></span>
          </label>
        </div>
      </div>
      <div v-if="listFilters.storage" class="catalogue">
        <h3 :class="{ active: option_filters.storage.length }">Ổ cứng</h3>
        <div
          :class="{ show: option_filters.storage.length }"
          class="catalogue__list"
        >
          <label
            v-for="storage in listFilters.storage"
            :key="storage"
            class="check-list"
          >
            <span class="text">{{ storage }}</span>
            <input
              v-model="option_filters.storage"
              type="checkbox"
              :value="storage"
            />
            <span class="checkmark"></span>
          </label>
        </div>
      </div>
      <div v-if="listFilters.display_size" class="catalogue">
        <h3 :class="{ active: option_filters.display_size.length }">
          Kích thước màn hình
        </h3>
        <div
          :class="{ show: option_filters.display_size.length }"
          class="catalogue__list"
        >
          <label
            v-for="display_size in listFilters.display_size"
            :key="display_size"
            class="check-list"
          >
            <span class="text">{{ display_size }}</span>
            <input
              v-model="option_filters.display_size"
              type="checkbox"
              :value="display_size"
            />
            <span class="checkmark"></span>
          </label>
        </div>
      </div>
      <div v-if="listFilters.display_type" class="catalogue">
        <h3 :class="{ active: option_filters.display_type.length }">
          Loại màn hình
        </h3>
        <div
          :class="{ show: option_filters.display_type.length }"
          class="catalogue__list"
        >
          <label
            v-for="display_type in listFilters.display_type"
            :key="display_type.name"
            :class="display_type"
            class="check-list"
          >
            <span class="text">{{ display_type.name }}</span>
            <input
              v-model="option_filters.display_type"
              type="checkbox"
              :value="display_type.id"
            />
            <span class="checkmark"></span>
          </label>
        </div>
      </div>
      <div v-if="listFilters.display_res" class="catalogue">
        <h3 :class="{ active: option_filters.display_res.length }">
          Độ phân giải
        </h3>
        <div
          :class="{ show: option_filters.display_res.length }"
          class="catalogue__list"
        >
          <label
            v-for="display_res in listFilters.display_res"
            :key="display_res"
            class="check-list"
          >
            <span class="text">{{ display_res }}</span>
            <input
              v-model="option_filters.display_res"
              type="checkbox"
              :value="display_res"
            />
            <span class="checkmark"></span>
          </label>
        </div>
      </div>
      <div v-if="listFilters.gpu_onboard" class="catalogue">
        <h3 :class="{ active: option_filters.gpu_onboard.length }">
          Card đồ họa
        </h3>
        <div
          :class="{ show: option_filters.gpu_onboard.length }"
          class="catalogue__list"
        >
          <label
            v-for="gpu_onboard in listFilters.gpu_onboard"
            :key="gpu_onboard"
            class="check-list"
          >
            <span class="text">{{ gpu_onboard }}</span>
            <input
              v-model="option_filters.gpu_onboard"
              type="checkbox"
              :value="gpu_onboard"
            />
            <span class="checkmark"></span>
          </label>
        </div>
      </div>
      <div v-if="listFilters.gpu_vram" class="catalogue">
        <h3 :class="{ active: option_filters.gpu_vram.length }">
          Bộ nhớ đồ họa
        </h3>
        <div
          :class="{ show: option_filters.gpu_vram.length }"
          class="catalogue__list"
        >
          <label
            v-for="gpu_vram in listFilters.gpu_vram"
            :key="gpu_vram"
            class="check-list"
          >
            <span class="text">{{ gpu_vram }}</span>
            <input
              v-model="option_filters.gpu_vram"
              type="checkbox"
              :value="gpu_vram"
            />
            <span class="checkmark"></span>
          </label>
        </div>
      </div>
      <div v-if="listFilters.weight" class="catalogue">
        <h3 :class="{ active: option_filters.weight.length }">Trọng lượng</h3>
        <div
          :class="{ show: option_filters.weight.length }"
          class="catalogue__list"
        >
          <label
            v-for="weight in listFilters.weight"
            :key="weight.name"
            class="check-list"
          >
            <span class="text">{{ weight.name }}</span>
            <input
              v-model="option_filters.weight"
              type="checkbox"
              :value="weight.id"
            />
            <span class="checkmark"></span>
          </label>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: 'ProductSideberFilter',
  components: {},
  props: [
    'brands',
    'listFilters',
    'clearFilters',
    'product_filters',
    'option_filters',
    'meta',
    'page',
    'brand',
  ],
  data() {
    return {
      showFilter: false,
      backStep: false,
      brandsFirst: [],
    }
  },
  computed: {
    isMorebrand() {
      return this.brands.length > 6
    },
  },
  mounted() {
    if (this.brands) {
      this.brandsFirst = this.brands.slice(0, 6)
    }
    const parenttitle = document.getElementsByClassName('catalogue')
    Array.prototype.forEach.call(parenttitle, function (el) {
      const elemtitle = el.firstElementChild
      elemtitle.addEventListener('click', function (event) {
        elemtitle.classList.toggle('active')
        elemtitle.nextElementSibling.classList.toggle('show')
      })
    })
  },
  methods: {
    moreBrands() {
      this.brandsFirst = this.brands
    },
  },
}
</script>
